@***************************************************************************************
@***************************************************************************************
@***************************************************************************************
@***************[ SOKOBAN v0.6b +12 Levels]***********[-=Slayer=-]***[2003]*************
@***************************************************************************************
@***************************************************************************************
@***************************************************************************************
.text
.code 16
.globl _start
.align 4
.word 0x20031004			@ version 3.10/4 OOK2 series PRGLoader 2.0
.string "SOKOBAN v0.6b"			@ Program Name 15 chars max
.org 0x14
_start:		b	.Main
.equ J7_3.10_4,0
@.xdef	DISPLAY				@ memory management functions
.xdef	MEMORY				@ memory management functions
.xdef	STRINGS				@ strings functions          
@.xdef	NVM				@ NVM functions              
.xdef	WINDOWS				@ windows functions          
@.xdef	MENU_EV				@ Menu Events functions      
@.xdef	MONITOR				@ Monitor Mode function      
.xdef	TIMER				@ Timer function      
@.xdef	NIMAR_DELAY			@ Delay :) functions
@.xdef	DIRECT_KEYBOARD			@ Keyboard functions
@.xdef	DEBUG				@ Debug functions            
.xdef	RANDOM
@.xdef	ROOT_GFX
.include "J70_NM_Lib.h"
@***************************************************************************************
.GetOfs:	push	{r1-r2,LR}	@ r0=x r1=y out: r0=ofs
		mov	r2,#96
		mul	r1,r2
		add	r0,r1
		ldr	r2,vidmem
		add	r0,r2
		pop	{r1-r2,PC}
@---------------------------------------------------------------------------------------
.HLine:		push	{r0-r3,LR}	@ r0=x r1=y r2=length r3=color
		bl	.GetOfs
_HLineLoop:	strb	r3,[r0]
		add	r0,#1
		sub	r2,#1
		cmp	r2,#0
		bne	_HLineLoop
		pop	{r0-r3,PC}
@---------------------------------------------------------------------------------------
.VLine:		push	{r0-r3,LR}	@ r0=x r1=y r2=length r3=color
		bl	.GetOfs
_VLineLoop:	strb	r3,[r0]
		add	r0,#96
		sub	r2,#1
		cmp	r2,#0
		bne	_VLineLoop
		pop	{r0-r3,PC}
@---------------------------------------------------------------------------------------
.GetSpriteOfs:	push	{r1-r2,LR}	@ r0=x r1=y out: r0=num
		mov	r2,#19
		mul	r1,r2
		add	r0,r1
		pop	{r1-r2,PC}
@---------------------------------------------------------------------------------------
.GetBrickOfs:	push	{r1-r3,LR}	@ r0=x	r1=y out: r0=ofs
		mov	r2,#96
		mov	r3,#5
		mul	r1,r2
		mul	r1,r3
		mul	r0,r3
		add	r0,r1
		ldr	r1,vidmem
		add	r0,r1
		pop	{r1-r3,PC}
@---------------------------------------------------------------------------------------
.DrawSprite5x5:	push	{r0-r4,LR}	@ r0=x r1=y r2=sprite addres
		bl	.GetBrickOfs
		mov	r4,#5
_sprite5x5loop:	ldrb	r3,[r2]
		strb	r3,[r0]
		add	r2,#1
		ldrb	r3,[r2]
		strb	r3,[r0,#1]
		add	r2,#1
		ldrb	r3,[r2]
		strb	r3,[r0,#2]
		add	r2,#1
		ldrb	r3,[r2]
		strb	r3,[r0,#3]
		add	r2,#1
		ldrb	r3,[r2]
		strb	r3,[r0,#4]
		add	r2,#1
		add	r0,#96
		sub	r4,#1
		cmp	r4,#0
		bne	_sprite5x5loop
		pop	{r0-r4,PC}
@---------------------------------------------------------------------------------------
.DrawAnim5x5:	push	{r2-r4,LR}
		ldrb	r4,[r2,#1]
		add	r2,#2
		mov	r3,#25
		mul	r3,r4
		add	r2,r3
		bl	.DrawSprite5x5
		pop	{r2-r4,PC}
@---------------------------------------------------------------------------------------
.UpdateAnim:	push	{r3-r4,LR}
		ldrb	r3,[r2]
		sub	r3,#1
		ldrb	r4,[r2,#1]
		add	r4,#1
		cmp	r4,r3
		ble	_UpdateNext
		mov	r4,#0
_UpdateNext:	strb	r4,[r2,#1]
		pop	{r3-r4,PC}
@---------------------------------------------------------------------------------------
.DrawSprite:	push	{r0-r5,LR}	@ r0=screen ofs r1=sprite r2=in sprite ofs
		ldrb	r3,[r1]
		ldrb	r4,[r1,#1]
		add	r1,r2
_NextRow:	mov	r5,#0
_NextPixel:	ldrb	r2,[r1,#2]
		cmp	r2,#4		@ 4 - transparent color
		beq	_NoPutPixel
		strb	r2,[r0,r5]
_NoPutPixel:	add	r5,#1
		add	r1,#1
		cmp	r5,r3
		bne	_NextPixel
		add	r0,#96
		sub	r4,#1
		cmp	r4,#0
		bne	_NextRow
		pop	{r0-r5,PC}
@---------------------------------------------------------------------------------------
.WriteOneNum:	push	{r1-r2,LR}	@ r0=screen ofs r1=number
		mov	r2,#18		@ number Size
		mul	r2,r1
		adr	r1,Numbers
		bl	.DrawSprite
		pop	{r1-r2,PC}
@---------------------------------------------------------------------------------------
.WriteLevNum:	push	{r0-r5,LR}	@ r0=x r1=y r2=number
		bl	.GetOfs
		mov	r5,r0
		mov	r0,r2
		mov	r1,#10
		bl	.divmod
		mov	r2,r1
		mov	r1,r0
		mov	r0,r5
		bl	.WriteOneNum
		add	r5,#4
		mov	r0,r5
		mov	r1,r2
		bl	.WriteOneNum
		pop	{r0-r5,PC}
@---------------------------------------------------------------------------------------
.WriteMovesNum:	push	{r0-r5,LR}	@ r0=x r1=y r2=number
		bl	.GetOfs
		mov	r5,r0
		mov	r0,r2
		ldr	r1,Thousand
		bl	.divmod
		mov	r2,r1
		mov	r1,r0
		mov	r0,r5
		bl	.WriteOneNum
		add	r5,#4
		mov	r0,r2
		mov	r1,#100
		bl	.divmod
		mov	r2,r1
		mov	r1,r0
		mov	r0,r5
		bl	.WriteOneNum
		add	r5,#4
		mov	r0,r2
		mov	r1,#10
		bl	.divmod
		mov	r2,r1
		mov	r1,r0
		mov	r0,r5
		bl	.WriteOneNum
		add	r5,#4
		mov	r0,r5
		mov	r1,r2
		bl	.WriteOneNum
		pop	{r0-r5,PC}
@***************************************************************************************
.align 2
vidmem:		.word	videoMem	@ <--- Video memory addres

.align 2
Thousand:	.word	1000

.WriteLevSpr:	push	{r0-r2,LR}
		mov	r0,#3
		mov	r1,#83
		bl	.GetOfs
		adr	r1,LevSprite
		mov	r2,#0
		bl	.DrawSprite
		pop	{r0-r2,PC}
LevSprite:	.byte	17,6
		.byte	0,4,4,0,0,4,0,4,0,4,0,0,4,0,4,4,4
		.byte	0,4,4,0,4,4,0,4,0,4,0,4,4,0,4,4,0
		.byte	0,4,4,0,0,4,0,4,0,4,0,0,4,0,4,4,4
		.byte	0,4,4,0,4,4,0,4,0,4,0,4,4,0,4,4,4
		.byte	0,4,4,0,4,4,0,0,0,4,0,4,4,0,4,4,0
		.byte	0,0,4,0,0,4,4,0,4,4,0,0,4,0,0,4,4

.WriteMovSpr:	push	{r0-r2,LR}
		mov	r0,#55
		mov	r1,#83
		bl	.GetOfs
		adr	r1,MovSprite
		mov	r2,#0
		bl	.DrawSprite
		pop	{r0-r2,PC}
MovSprite:	.byte	22,6
		.byte	0,4,4,4,0,4,0,0,0,4,0,4,0,4,0,0,4,0,0,0,4,4
		.byte	0,0,4,0,0,4,0,4,0,4,0,4,0,4,0,4,4,0,4,4,4,0
		.byte	0,0,0,0,0,4,0,4,0,4,0,4,0,4,0,0,4,0,0,0,4,4
		.byte	0,4,0,4,0,4,0,4,0,4,0,4,0,4,0,4,4,4,4,0,4,4
		.byte	0,4,4,4,0,4,0,4,0,4,0,0,0,4,0,4,4,0,4,0,4,0
		.byte	0,4,4,4,0,4,0,0,0,4,4,0,4,4,0,0,4,0,0,0,4,4

.align 2
Numbers:	.byte	3,6
Zero:		.byte	4,0,4,0,4,0,0,4,0,0,4,0,0,4,0,4,0,4
One:		.byte	4,4,0,4,0,0,4,4,0,4,4,0,4,4,0,4,4,0
Two:		.byte	4,0,4,0,4,0,4,4,0,4,0,4,0,4,4,0,0,0
Three:		.byte	0,0,4,4,4,0,4,0,4,4,4,0,0,4,0,4,0,4
Four:		.byte	4,4,0,4,0,0,4,0,0,0,4,0,0,0,0,4,4,0
Five:		.byte	0,0,0,0,4,4,0,0,4,4,4,0,0,4,0,0,0,4
Six:		.byte	4,0,0,0,4,4,0,0,4,0,4,0,0,4,0,4,0,4
Seven:		.byte	0,0,0,4,4,0,4,0,4,4,0,4,4,0,4,4,0,4
Eight:		.byte	4,0,4,0,4,0,4,0,4,0,4,0,0,4,0,4,0,4
Nine:		.byte	4,0,4,0,4,0,0,4,0,4,0,0,4,4,0,0,0,4
@***************************************************************************************
@************************************[ Events ]*****************************************
@***************************************************************************************
.align 1
.CallOldEvent:	push	{r5}
		ldr	r5,OldEvents
		lsl	r4,r4,#3
		add	r4,r4,#12
		ldr	r4,[r5,r4]
		pop	{r5}
		bx	r4
.SetNewEvent:	ldr	r2,NewEvents
		lsl	r0,r0,#3
		add	r0,r0,#12
		str	r1,[r2,r0]
		mov	PC,LR
.HookEvents:	push	{r4-r5,LR}
		mov	r4,r0
		mov	r0,#0xA4  /* 2*41*8 = 0x290 */
		lsl	r0,r0,#2
		mov	r1,#8
		add	r0,r0,r1
		bl	.malloc
		adr	r1,OldEvents
		str	r0,[r1]
		ldr	r1,[r4,#0x10]
		mov	r2,#0xFF
		add	r2,r2,#0x49
		bl	.memcpy
		mov	r1,r0
		mov	r2,#0xFF
		add	r2,r2,#0x49
		add	r0,r0,r2
		adr	r5,NewEvents
		str	r0,[r5]
		mov	r5,r0
		bl	.memcpy
							@ Here you can set any event handler
		mov	r0,#0x15
		adr	r1,.NewEvent_Key
		add	r1,r1,#1
		bl	.SetNewEvent
		mov	r0,#0x1A
		adr	r1,.NewEvent_Destroy
		add	r1,r1,#1
		bl	.SetNewEvent
		mov	r0,#0x13
		adr	r1,.NewEvent_Paint
		add	r1,r1,#1
		bl	.SetNewEvent
		mov	r0,#0x29
		adr	r1,.MyTimerFunc
		add	r1,r1,#1
		bl	.SetNewEvent
		str	r5,[r4,#0x10]
		pop	{r4-r5,PC}
.UnhookEvents:	push	{LR}
		ldr	r0,OldEvents
		bl	.free
		pop	{PC}
.align 2
OldEvents:	.word 0
NewEvents:	.word 0
@***************************************************************************************
@*************************************[ Main ]******************************************
@***************************************************************************************
.Main:		push	{r4-r7,lr}
		mov	r6,r0
		bl	.CopyLevel
							@ You can place some initialization code here,
							@ but you can use OnCreate event too
		bl	.GetWindowManager
		mov	r5,r0
		mov	r0,#0x70
		bl	.malloc
		mov	r4,r0
		mov	r0,r6
		cmp	r0,#0
		bne	.skip_wnd
		mov	r0,#0x7D
		lsl	r0,r0,#4
		bl	.GetWindowById
.skip_wnd:	mov	r2,r5
		mov	r1,r0
		mov	r0,r4
		bl	.cWindowWidget_Create
		mov	r0,r4
		bl	.HookEvents
		adr	r0,TimerFuncs
		str	r0,[r4,#0x4C]
		adr	r1,.MyTimerFunc
		add	r1,#1
		str	r1,[r0,#0xC]
		adr	r1,.NewEvent_Destroy
		add	r1,#1
		str	r1,[r0,#0x14]
		mov	r0,#0x50
		add	r0,r4,r0
		mov	r1,#0x4C
		add	r1,r4,r1
		bl	.Time_CreateServer
		mov	r0,#0x50
		add	r0,r4,r0
		ldr	r1,Interval
		mov	r2,#1
		bl	.Time_SetInterval		@ Init timer
		mov	r0,r4
		pop	{r4-r7,pc}
@***************************************************************************************
@******************************[ New event handlers ]***********************************
@***************************************************************************************
.align 2
.NewEvent_Key:	push	{r4,LR}				@@@@@@@@@ OnKeyPressed @@@@@@@@@
		push	{r0-r7}
		mov	r3,r1
		ldrh	r1,[r3,#0xE]
		ldrh	r0,[r3,#0xC]
							@ Your keyhandler code here
							@  r1 - Key scancode
							@       0x30 .. 0x39 - "0".."9"
							@       0x23 - "#"
							@       0x2a - "*"
							@  r0 - Event type (101h,106h,107h,...)
							@          0x106 - key pressed
							@          0x107 - key unpressed
							@        0x101 & scan 0x09 - RedButton pressed
							@        0x101 & scan 0x56 - CenterKey pressed
							@        0x101 & scan 0x08 - CenterKey holded
							@        0x101 & scan 0x07 - CenterKey unpressed
							@        0x101 & scan 0x0b - GreenButton pressed
							@        0x101 & scan 0x03 - JogUp
							@        0x101 & scan 0x05 - JogDown
							@        0x101 & scan 0x56 - JogPress
							@        0x101 & scan 0x4d - JogRelase
							@        0x101 & scan 0x0c - JogHold
		mov	r3,#2
		add	r3,#0xFF
		cmp	r0,r3
		bne	KeysScan
		cmp	r1,#0x05
		beq	NextLevel
		cmp	r1,#0x03
		beq	PervousLevel
KeysScan:	mov	r3,#7
		add	r3,#0xFF
		cmp	r0,r3
		bne	KeyEnd
		cmp	r1,#0x31
		beq	Help
		adr	r4,xy01
		ldrb	r2,[r4]
		ldrb	r3,[r4,#1]
		cmp	r1,#0x32
		beq	Up
		cmp	r1,#0x34
		beq	Left
		cmp	r1,#0x36
		beq	Right
		cmp	r1,#0x35
		beq	Down
		cmp	r1,#0x38
		beq	Down
		cmp	r1,#0x2A
		beq	Reset
		cmp	r1,#0x23
		beq	Ground
ContinueKey:	bl	.CurrLevel
		adr	r2,xy01
		ldrb	r0,[r2,#2]
		ldrb	r1,[r2,#3]
		bl	.GetSpriteOfs
		ldrb	r1,[r7,r0]
		cmp	r1,#0
		beq	FreeSpace
		cmp	r1,#2
		beq	ChestSpace
		cmp	r1,#6
		beq	ChestOKSpace
		cmp	r1,#3
		beq	FreeSpace
KeyEnd:		pop	{r0-r7}               		@ In every handler you NEED to pass
		mov	r4,#0x15              		@ old registers r0-r3 to CallOldEvent
		bl	.CallOldEvent
		pop	{r4,PC}
Help:		mov	r0,r7
		adr	r1,help_txt
		mov	r2,#0
		mov	r3,#3
		bl	.InfoBox
		b	ContinueKey
Up:		sub	r3,#1
		strb	r2,[r4,#2]
		strb	r3,[r4,#3]
		b	ContinueKey
Left:		sub	r2,#1
		strb	r2,[r4,#2]
		strb	r3,[r4,#3]
		b	ContinueKey
Right:		add	r2,#1
		strb	r2,[r4,#2]
		strb	r3,[r4,#3]
		b	ContinueKey
Down:		add	r3,#1
		strb	r2,[r4,#2]
		strb	r3,[r4,#3]
		b	ContinueKey
Reset:		bl	.CopyLevel
		b	ContinueKey
Ground:		push	{r0-r2}
		adr	r2,bgTemp
		ldrb	r0,[r2]
		adr	r1,bgNum
		ldrb	r1,[r1]
		add	r0,#1
		cmp	r0,r1
		bne	GroundLoop
		mov	r0,#0
GroundLoop:	strb	r0,[r2]
		pop	{r0-r2}
		b	ContinueKey
NextLevel:	bl	.NextLevel
		b	ContinueKey
PervousLevel:	bl	.PervousLevel
		b	ContinueKey
FreeSpace:	adr	r2,xy01
		ldrb	r0,[r2,#2]
		ldrb	r1,[r2,#3]
		strb	r0,[r2]
		strb	r1,[r2,#1]

		bl	.AddMoves

		b	KeyEnd
ChestSpace:	adr	r6,xy01
		ldrb	r0,[r6,#2]
		ldrb	r1,[r6,#3]
		ldrb	r2,[r6]
		ldrb	r3,[r6,#1]
		add	r0,r0
		sub	r0,r2
		add	r1,r1
		sub	r1,r3
		bl	.GetSpriteOfs
		bl	.CurrLevel
		ldrb	r4,[r7,r0]
		cmp	r4,#0
		beq	C01
		cmp	r4,#3
		bne	KeyEnd
		mov	r4,#6
		b	C02
C01:		mov	r4,#2
C02:		strb	r4,[r7,r0]
		ldrb	r0,[r6,#2]
		ldrb	r1,[r6,#3]
		push	{r0}
		bl	.GetSpriteOfs
		mov	r4,#0
		strb	r4,[r7,r0]
		pop	{r0}
		strb	r0,[r6]
		strb	r1,[r6,#1]

		bl	.AddMoves

		b	KeyEnd
ChestOKSpace:	adr	r6,xy01
		ldrb	r0,[r6,#2]
		ldrb	r1,[r6,#3]
		ldrb	r2,[r6]
		ldrb	r3,[r6,#1]
		add	r0,r0
		sub	r0,r2
		add	r1,r1
		sub	r1,r3
		bl	.GetSpriteOfs
		bl	.CurrLevel
		ldrb	r4,[r7,r0]
		cmp	r4,#0
		beq	C03
		cmp	r4,#3
		bne	KeyEnd
		mov	r4,#6
		b	C04
C03:		mov	r4,#2
C04:		strb	r4,[r7,r0]
		ldrb	r0,[r6,#2]
		ldrb	r1,[r6,#3]
		push	{r0}
		bl	.GetSpriteOfs
		mov	r4,#3
		strb	r4,[r7,r0]
		pop	{r0}
		strb	r0,[r6]
		strb	r1,[r6,#1]

		bl	.AddMoves

		b	KeyEnd
.align 2
.NewEvent_Destroy:					@@@@@@@@ OnDestroy @@@@@@@@
		push	{r4,LR}
		push	{r0-r3}
		mov	r1,#0x50
		add	r0,r0,r1
		mov	r1,#2				@ Destroy timer
		bl	.Time_DestroyServer
							@ Place your deinitialization here
							@ (some free(), etc)
		pop	{r0-r3}
		mov	r4,#0x1A
		bl	.CallOldEvent
		bl	.UnhookEvents
		pop	{r4,PC}
.align 2
.NewEvent_Paint:
		push	{r4-r5,LR}
		mov	r5,r0
		mov	r4,#0x13
		bl	.CallOldEvent			@ for widget this clear screen to color 3
		bl	.DrawLabyrinth
		bl	.DrawBox
		bl	.DrawPlayer
		bl	.UpdateSprites

		bl	.LevDone
		ldrb	r0,[r0]
		cmp	r0,#0
		bne	NNN
		bl	.NextLevel
		bl	.LevDone
		add	r1,#0xFF
		strb	r1,[r0]

		mov	r0,r7
		adr	r1,next_txt
		mov	r2,#0
		mov	r3,#0
		bl	.InfoBox
NNN:
							@ Insert any code here
		pop	{r4-r5,PC}			@ After return, screen is repainted, you don't
							@ need to call Repaint in this Paint_event
.align 2
.MyTimerFunc:	push	{r4-r6,lr}			@@@@@@@@ OnTimer @@@@@@@@
		mov	r4,r0
							@ Your timer handler code here
		mov	r0,r4				@ This will repaint the window using Paint event
		bl	.WindowRepaint			@ Use this metod for drawing, don't draw in timer
		mov	r0,#0x50
		add	r0,r4,r0
		bl	.Time_Repeat			@ Refresh timer - only one parameter r4+0x50
		pop	{r4-r6,pc}
@***************************************************************************************
.align 2
Interval:	.word	30				@ Not in ms - smaller -> shorter time
TimerFuncs:	.word	0x4C				@ Functions base for timer event structure
		.word	0
		.word	0xFFB4
		.word	0x0
		.word	0xFFB4
		.word	0x0
@***************************************************************************************
.align 2
next_txt:	.string	"Well Done!\nNext Level."
.align 2
help_txt:	.string	"   -=HELP PAGE=-\n\nControl keys:\n2-UP, 4-LEFT\n6-RIGHT, 8-DOWN\n1-this HELP page\n*-RESET level\n#-CHANGE back-\nground texture JogDial-CHANGE level \n\n -=Slayer=- 2003"

@***************************************************************************************
.DrawLabyrinth:	push	{r0-r7,LR}
		bl	.LevDone
		mov	r5,r0
		mov	r0,#0
		mov	r1,#0
		strb	r0,[r5]
		bl	.CurrLevel
		mov	r5,r7
LoopDrawing:	ldrb	r2,[r5]
		cmp	r2,#0xFF
		beq	ExitDrawing
		cmp	r2,#0
		beq	ClearPosition
		cmp	r2,#1
		beq	DrawBrick
		cmp	r2,#2
		beq	DrawChest
		cmp	r2,#3
		beq	DrawPlace
		cmp	r2,#6
		beq	DrawChestOK
		cmp	r2,#4
		beq	DrawGround
		cmp	r2,#5
		beq	StorePlayerPos
ContinueDraw1:	add	r0,#1
		cmp	r0,#19
		bne	ContinueDraw2
		mov	r0,#0
		add	r1,#1
ContinueDraw2:	add	r5,#1
		b	LoopDrawing
ExitDrawing:	pop	{r0-r7,PC}
StorePlayerPos:	adr	r2,xy01
		strb	r0,[r2]
		strb	r1,[r2,#1]
		bl	.CurrLevel
		mov	r2,r7
		push	{r0-r1}
		bl	.GetSpriteOfs
		mov	r1,#0
		strb	r1,[r2,r0]
		pop	{r0-r1}
ClearPosition:	adr	r2,empty
		bl	.DrawSprite5x5
		b	ContinueDraw1
DrawBrick:	adr	r2,brick
		bl	.DrawSprite5x5
		b	ContinueDraw1
DrawChest:	adr	r2,chest
		bl	.DrawSprite5x5
		push	{r0}
		bl	.LevDone
		mov	r3,r0
		pop	{r0}
		ldrb	r4,[r3]
		add	r4,#1
		strb	r4,[r3]
		b	ContinueDraw1
DrawChestOK:	adr	r2,chestOK
		bl	.DrawAnim5x5
		b	ContinueDraw1
DrawPlace:	adr	r2,place
		bl	.DrawAnim5x5
		b	ContinueDraw1
DrawGround:	bl	.BGCalc
		bl	.DrawAnim5x5
		b	ContinueDraw1
@---------------------------------------------------------------------------------------
.DrawPlayer:	push	{r0-r4,LR}
		adr	r2,xy01
		ldrb	r0,[r2]
		ldrb	r1,[r2,#1]
		adr	r2,player
		bl	.DrawAnim5x5
		pop	{r0-r4,PC}
@---------------------------------------------------------------------------------------
.UpdateSprites:	push	{r2,LR}
		adr	r2,player
		bl	.UpdateAnim
		bl	.BGCalc
		bl	.UpdateAnim
		adr	r2,chestOK
		bl	.UpdateAnim
		adr	r2,place
		bl	.UpdateAnim
		pop	{r2,PC}
@---------------------------------------------------------------------------------------
.BGCalc:	push	{r0-r1,LR}
		adr	r2,bg1
		adr	r0,bgTemp
		ldrb	r0,[r0]
		adr	r1,bgSize
		ldrb	r1,[r1]
		mul	r0,r1
		add	r2,r0
		pop	{r0-r1,PC}
@---------------------------------------------------------------------------------------
.ResetXY01:	push	{r0-r1,LR}
		adr	r0,xy01
		mov	r1,#0
		strb	r1,[r0]
		strb	r1,[r0,#1]
		strb	r1,[r0,#2]
		strb	r1,[r0,#3]
		pop	{r0-r1,PC}
@***************************************************************************************
.align 2
xy01:		.byte	0,0,0,0				@ x0,y0,x1,y1
.align 2
bgNum:		.byte	3
.align 2
bgTemp:		.byte	0
.align 2
bgSize:		.byte	128
.align 2
empty:		.byte	3,3,3,3,3
		.byte	3,3,3,3,3
		.byte	3,3,3,3,3
		.byte	3,3,3,3,3
		.byte	3,3,3,3,3
.align 2
brick:		.byte	1,2,0,0,0
		.byte	1,2,1,1,1
		.byte	2,2,2,2,2
		.byte	0,0,1,2,0
		.byte	1,1,1,2,1
.align 2
place:		.byte	4,0
		.byte	3,3,3,3,3	@ 1
		.byte	3,0,0,2,3
		.byte	3,0,0,2,3
		.byte	3,2,2,2,3
		.byte	3,3,3,3,3
		.byte	3,3,3,3,3	@ 2
		.byte	3,2,0,0,3
		.byte	3,2,0,0,3
		.byte	3,2,2,2,3
		.byte	3,3,3,3,3
		.byte	3,3,3,3,3	@ 3
		.byte	3,2,2,2,3
		.byte	3,2,0,0,3
		.byte	3,2,0,0,3
		.byte	3,3,3,3,3
		.byte	3,3,3,3,3	@ 4
		.byte	3,2,2,2,3
		.byte	3,0,0,2,3
		.byte	3,0,0,2,3
		.byte	3,3,3,3,3
.align 2
chest:		.byte	0,1,1,1,1
		.byte	1,0,3,3,1
		.byte	1,3,0,3,1
		.byte	1,3,3,0,1
		.byte	1,1,1,1,0
.align 2
chestOK:	.byte	4,0
		.byte	0,1,1,1,1	@ 1
		.byte	1,0,3,3,1
		.byte	1,3,0,3,1
		.byte	1,3,3,0,1
		.byte	1,1,1,1,0
		.byte	1,1,1,1,1	@ 2
		.byte	1,3,3,3,1
		.byte	0,0,0,0,0
		.byte	1,3,3,3,1
		.byte	1,1,1,1,1
		.byte	1,1,1,1,0	@ 3
		.byte	1,3,3,0,1
		.byte	1,3,0,3,1
		.byte	1,0,3,3,1
		.byte	0,1,1,1,1
		.byte	1,1,0,1,1	@ 4
		.byte	1,3,0,3,1
		.byte	1,3,0,3,1
		.byte	1,3,0,3,1
		.byte	1,1,0,1,1
.align 2
bg1:		.byte	5,0
		.byte	0,0,0,0,0	@ 1
		.byte	0,3,3,3,3
		.byte	0,3,3,3,3
		.byte	0,3,3,3,3
		.byte	0,3,3,3,3
		.byte	3,0,3,3,3	@ 2
		.byte	0,0,0,0,0
		.byte	3,0,3,3,3
		.byte	3,0,3,3,3
		.byte	3,0,3,3,3
		.byte	3,3,0,3,3	@ 3
		.byte	3,3,0,3,3
		.byte	0,0,0,0,0
		.byte	3,3,0,3,3
		.byte	3,3,0,3,3
		.byte	3,3,3,0,3	@ 4
		.byte	3,3,3,0,3
		.byte	3,3,3,0,3
		.byte	0,0,0,0,0
		.byte	3,3,3,0,3
		.byte	3,3,3,3,0	@ 5
		.byte	3,3,3,3,0
		.byte	3,3,3,3,0
		.byte	3,3,3,3,0
		.byte	0,0,0,0,0
.align 2
bg2:		.byte	5,0
		.byte	3,3,3,3,3	@ 1
		.byte	3,3,3,3,3
		.byte	3,3,0,3,3
		.byte	3,3,3,3,3
		.byte	3,3,3,3,3
		.byte	3,3,3,3,3	@ 2
		.byte	3,0,0,0,3
		.byte	3,0,0,0,3
		.byte	3,0,0,0,3
		.byte	3,3,3,3,3
		.byte	0,0,0,0,0	@ 3
		.byte	0,0,0,0,0
		.byte	0,0,0,0,0
		.byte	0,0,0,0,0
		.byte	0,0,0,0,0
		.byte	3,3,3,3,3	@ 4
		.byte	3,0,0,0,3
		.byte	3,0,0,0,3
		.byte	3,0,0,0,3
		.byte	3,3,3,3,3
		.byte	3,3,3,3,3	@ 5
		.byte	3,3,3,3,3
		.byte	3,3,0,3,3
		.byte	3,3,3,3,3
		.byte	3,3,3,3,3
.align 2
bg3:		.byte	0,0
		.byte	2,2,2,2,2
		.byte	2,3,3,3,2
		.byte	2,3,3,3,2
		.byte	2,3,3,3,2
		.byte	2,2,2,2,2
.align 2
player:		.byte	6,0
		.byte	3,0,0,0,3	@ 1
		.byte	0,0,0,0,0
		.byte	0,0,0,0,0
		.byte	0,0,0,0,0
		.byte	3,0,0,0,3
		.byte	3,0,0,0,3	@ 2
		.byte	0,1,1,1,0
		.byte	0,1,1,1,0
		.byte	0,1,1,1,0
		.byte	3,0,0,0,3
		.byte	3,0,0,0,3	@ 3
		.byte	0,2,2,2,0
		.byte	0,2,2,2,0
		.byte	0,2,2,2,0
		.byte	3,0,0,0,3
		.byte	3,0,0,0,3	@ 4
		.byte	0,3,3,3,0
		.byte	0,3,3,3,0
		.byte	0,3,3,3,0
		.byte	3,0,0,0,3
		.byte	3,0,0,0,3	@ 5
		.byte	0,2,2,2,0
		.byte	0,2,2,2,0
		.byte	0,2,2,2,0
		.byte	3,0,0,0,3
		.byte	3,0,0,0,3	@ 6
		.byte	0,1,1,1,0
		.byte	0,1,1,1,0
		.byte	0,1,1,1,0
		.byte	3,0,0,0,3
@***************************************************************************************
.CurrLevel:	push	{LR}
		adr	r7,CurrentLevel
		pop	{PC}
.LevDone:	push	{LR}
		adr	r0,LevelDone
		pop	{PC}
@---------------------------------------------------------------------------------------
.CopyLevel:	push	{r0-r4,LR}
		adr	r0,Level1
		adr	r1,LevelNumber
		ldrb	r1,[r1]
		mov	r2,#152
		mov	r4,#2
		mul	r1,r2
		mul	r1,r4
		add	r0,r1
		adr	r1,CurrentLevel
		mov	r4,#0
LevelCopy:	ldrb	r3,[r0,r4]
		strb	r3,[r1,r4]
		add	r4,#1
		ldrb	r3,[r0,r4]
		strb	r3,[r1,r4]
		add	r4,#1
		sub	r2,#1
		cmp	r2,#0
		bne	LevelCopy
		bl	.ResetMoves
		bl	.ResetXY01
		pop	{r0-r4,PC}
@---------------------------------------------------------------------------------------
.NextLevel:	push	{r0-r2,LR}
		adr	r0,LevelNumber
		adr	r1,Levels
		ldrb	r2,[r0]
		ldrb	r1,[r1]
		sub	r1,#1
		cmp	r2,r1
		beq	nexit
		add	r2,#1
		strb	r2,[r0]	
		bl	.CopyLevel
		pop	{r0-r2,PC}
nexit:		bl	.ResetMoves
		strb	r1,[r0]
		bl	.CopyLevel
		pop	{r0-r2,PC}
@---------------------------------------------------------------------------------------
.PervousLevel:	push	{r0-r1,LR}
		adr	r0,LevelNumber
		ldrb	r1,[r0]
		cmp	r1,#0
		beq	pexit
		sub	r1,#1
		strb	r1,[r0]
		bl	.CopyLevel
		pop	{r0-r1,PC}
pexit:		bl	.ResetMoves
		mov	r1,#0
		strb	r1,[r0]
		bl	.CopyLevel
		pop	{r0-r1,PC}
@---------------------------------------------------------------------------------------
.AddMoves:	push	{r0-r1,LR}
		adr	r0,moves
		ldr	r1,[r0]
		add	r1,#1
		str	r1,[r0]
		pop	{r0-r1,PC}
@---------------------------------------------------------------------------------------
.ResetMoves:	push	{r0-r1,LR}
		adr	r0,moves
		mov	r1,#0
		str	r1,[r0]
		pop	{r0-r1,PC}
@---------------------------------------------------------------------------------------
.DrawBox:	push	{r0-r4,LR}
		mov	r3,#0
		mov	r0,#0
		mov	r1,#0
		mov	r2,#96
		bl	.HLine
		mov	r1,#91
		bl	.HLine
		mov	r1,#80
		bl	.HLine
		mov	r1,#0
		mov	r2,#91
		bl	.VLine
		mov	r0,#95
		bl	.VLine
		
		mov	r4,#10
		mov	r0,#1
		mov	r1,#81
		mov	r2,#94
		mov	r3,#2
_BoxLoop:	bl	.HLine
		add	r1,#1
		sub	r4,#1
		cmp	r4,#0
		bne	_BoxLoop


		bl	.WriteLevSpr
		bl	.WriteMovSpr
		mov	r0,#21
		mov	r1,#83
		adr	r2,LevelNumber
		ldrb	r2,[r2]
		add	r2,#1
		bl	.WriteLevNum
		mov	r0,#78		@+5
		adr	r2,moves
		ldr	r2,[r2]
		bl	.WriteMovesNum

		pop	{r0-r4,PC}
@***************************************************************************************
.align 2
moves:		.word	0
.align 2
LevelDone:	.byte	0xFF
.align 2
LevelNumber:	.byte	0
.align 2
Levels:		.byte	lev
.align 2
CurrentLevel:	.byte	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		.byte	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		.byte	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		.byte	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		.byte	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		.byte	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		.byte	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		.byte	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		.byte	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		.byte	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		.byte	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		.byte	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		.byte	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		.byte	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		.byte	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		.byte	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		.byte	0xFF
.include "levels.h"
		